Add SurveyJS Dashboard to a React Application

This tutorial explains how to integrate SurveyJS Dashboard into a React application and visualize survey results. Follow the steps below to set up and render a dashboard:

The final result is an interactive dashboard similar to the one shown below:

View Live Example

View Full Code on GitHub

If you need a preconfigured starter project with all SurveyJS components, refer to the following repositories:

Install the survey-analytics npm Package

SurveyJS Dashboard is distributed as the survey-analytics npm package. Install it using the following command:

npm install survey-analytics

SurveyJS Dashboard uses the Chart.js library for data visualization. This dependency is installed automatically.

Configure Styles

Add Themes

Create a React component that will render your dashboard and import the SurveyJS Dashboard stylesheet as shown below:

// components/Dashboard.tsx
import 'survey-analytics/survey.analytics.css';

Add Fonts

Starting with SurveyJS v3.0.4, fonts are no longer included in SurveyJS packages. Load Open Sans separately to preserve the default appearance, unless your application already does so. If you use a custom font, load it instead. Otherwise, the browser uses a fallback font, which may affect spacing and layout.

To add Open Sans using Fontsource, run the following command:

npm install @fontsource/open-sans

The following example imports font weights 400, 600, and 700. Place the font imports in your application's entry file or root layout to load them once for all SurveyJS components.

// app/layout.tsx or pages/_app.tsx
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';

Load Survey Results

When a respondent completes a survey, a JSON object with their answers is passed to the SurveyModel's onComplete event handler. Send this object to your server and store it with a specific survey ID (see Handle Survey Completion). A collection of these JSON objects forms the data source for the Dashboard. You can aggregate this data either on the server or on the client.

Server-Side Data Processing

By default, the Dashboard loads all stored responses and processes them in the browser, which can degrade performance as the dataset grows. To optimize load times, move aggregation logic to the server and return only precomputed statistics to the client. See the following demo for a reference implementation:

SurveyJS Dashboard: Server-Side Data Processing Demo Example

Client-Side Data Processing

With client-side processing, the Dashboard loads the full dataset at startup and performs aggregation in the browser. This approach requires more bandwidth and client-side resources, but is sufficient and often simpler for smaller datasets.

To retrieve results, send a request to your backend and return an array of JSON objects:

// components/Dashboard.tsx
// ...
import { useEffect, useState } from 'react';
import { Dashboard } from 'survey-analytics';

const SURVEY_ID = 1;

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard>();

  useEffect(() => {
    loadSurveyResults(`https://your-web-service.com/${SURVEY_ID}`)
      .then((surveyResults: any[]) => {
        // ...
        // Configure and render the Dashboard here
        // Refer to the section below
        // ...
      })
      .catch((error) => {
        console.error('Failed to load survey results:', error);
      });
  }, []);

  return "...";
}

function loadSurveyResults(url: string): Promise<any[]> {
  return fetch(url, {
    method: 'GET',
    headers: {
      'Content-Type': 'application/x-www-form-urlencoded'
    }
  })
    .then((response) => {
      if (!response.ok) {
        throw new Error(`Request failed with status ${response.status}`);
      }
      return response.json();
    })
    .catch((error) => {
      throw new Error(error.message || 'Network error');
    });;
}

For demonstration purposes, this tutorial uses predefined survey results:

// components/Dashboard.tsx
// ...
const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

const surveyResults = [
  { "satisfaction-score": 5, "nps-score": 10 },
  { "satisfaction-score": 5, "nps-score": 9 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 2, "nps-score": 3 }
];

Configure the Dashboard

Pass an IDashboardOptions object to the Dashboard constructor to configure the dashboard.

Specify the data array to provide survey results. You can then either auto-generate dashboard items based on survey questions or define them manually.

Auto-Generate Dashboard Items

To generate dashboard items automatically, assign survey questions to the questions property. Use the SurveyModel's getAllQuestions() method to retrieve them.

Each generated item inherits the question's name and title. The Dashboard also automatically selects a suitable visualization type and populates the list of available alternative types (availableTypes) that users can switch between.

Use the items array to control which items appear and override their configuration. This array can include question names and full configuration objects. When you specify a configuration object, it is merged with the auto-generated settings.

The following example uses the items array to set the default NPS visualization type for the nps-score question:

// components/Dashboard.tsx
// ...
import { useEffect, useState } from 'react';
import { Model } from 'survey-core';
import { Dashboard } from 'survey-analytics';

const SURVEY_ID = 1;

const surveyJson = { /* ... */ };
const surveyResults = [ /* ... */ ];

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard | null>(null);

  useEffect(() => {
    const survey = new Model(surveyJson);

    const dashboardInstance = new Dashboard({
      questions: survey.getAllQuestions(),
      data: surveyResults,
      items: [
        "satisfaction-score",
        {
          name: "nps-score",
          type: "nps"
        }
      ]
    });

    setDashboard(dashboardInstance);
  }, []);

  return "...";
}
View Full Code
// app/layout.tsx or pages/_app.tsx
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
// components/Dashboard.tsx
import 'survey-analytics/survey.analytics.css';
import { useState } from 'react';
import { Model } from 'survey-core';
import { IDashboardOptions, Dashboard } from 'survey-analytics';

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

const surveyResults = [
  { "satisfaction-score": 5, "nps-score": 10 },
  { "satisfaction-score": 5, "nps-score": 9 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 2, "nps-score": 3 }
];

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard | null>(null);

  useEffect(() => {
    const survey = new Model(surveyJson);

    const dashboardInstance = new Dashboard({
      questions: survey.getAllQuestions(),
      data: surveyResults,
      items: [
        "satisfaction-score",
        {
          name: "nps-score",
          type: "nps"
        }
      ]
    });

    setDashboard(dashboardInstance);
  }, []);

  return "...";
}

Configure Dashboard Items Manually

If your dashboard is not based on a survey schema, configure all items explicitly. Populate the items array with IDashboardItemOptions objects. Use the name property to bind each item to a data field.

// components/Dashboard.tsx
// ...
import { useEffect, useState } from 'react';
import { Model } from 'survey-core';
import { Dashboard } from 'survey-analytics';

const SURVEY_ID = 1;

const surveyJson = { /* ... */ };
const surveyResults = [ /* ... */ ];

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard | null>(null);

  useEffect(() => {
    const survey = new Model(surveyJson);

    const dashboardInstance = new Dashboard({
      data: surveyResults,
      items: [
        {
          name: "satisfaction-score",
          type: "bar",
          title: "CSAT",
          availableTypes: [ "bar", "vbar", "pie", "gauge" ]
        },
        {
          name: "nps-score",
          type: "nps",
          title: "NPS Score",
          allowChangeType: false
        }
      ]
    });

    setDashboard(dashboardInstance);
  }, []);

  return "...";
}
View Full Code
// app/layout.tsx or pages/_app.tsx
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
// components/Dashboard.tsx
import 'survey-analytics/survey.analytics.css';
import { useState } from 'react';
import { Model } from 'survey-core';
import { IDashboardOptions, Dashboard } from 'survey-analytics';

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

const surveyResults = [
  { "satisfaction-score": 5, "nps-score": 10 },
  { "satisfaction-score": 5, "nps-score": 9 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 2, "nps-score": 3 }
];

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard | null>(null);

  useEffect(() => {
    const survey = new Model(surveyJson);

    const dashboardInstance = new Dashboard({
      data: surveyResults,
      items: [
        {
          name: "satisfaction-score",
          type: "bar",
          title: "CSAT",
          availableTypes: [ "bar", "vbar", "pie", "gauge" ]
        },
        {
          name: "nps-score",
          type: "nps",
          title: "NPS Score",
          allowChangeType: false
        }
      ]
    });

    setDashboard(dashboardInstance);
  }, []);

  return "...";
}

Render the Dashboard

Add a container element to the component template and call the render(containerId) method on the Dashboard instance you configured to mount the dashboard.

SurveyJS components are client-side components. Explicitly mark the React component that renders a SurveyJS component as client code using the 'use client' directive.

// components/Dashboard.tsx
'use client'
// ...
import { useEffect } from 'react';

export default function DashboardComponent() {
  // ...
  useEffect(() => {
    // ...
    // Render the dashboard
    dashboardInstance.render("dashboard");

    // Cleanup when component unmounts
    return () => {
      dashboardInstance.clear();
    };
  }, []);

  return (
    <div id="dashboard" />
  );
}

The lack of SSR support may cause hydration errors if a SurveyJS component is pre-rendered on the server. To ensure against those errors, use dynamic imports with ssr: false for React components that render SurveyJS components. The following code shows how to do this in Next.js:

// dashboard/page.tsx
import dynamic from "next/dynamic";

const Dashboard = dynamic(() => import('@/components/Dashboard'), {
  ssr: false,
});

export default function SurveyDashboard() {
  return (
    <Dashboard />
  );
}

Run the application with npm run dev and open http://localhost:3000/ in your browser.

View Full Code
// app/layout.tsx or pages/_app.tsx
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
// components/Dashboard.tsx
'use client'

import { useState, useEffect } from 'react';
import 'survey-analytics/survey.analytics.css';
import { Model } from 'survey-core';
import { Dashboard } from 'survey-analytics';

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

const surveyResults = [
  { "satisfaction-score": 5, "nps-score": 10 },
  { "satisfaction-score": 5, "nps-score": 9 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 3, "nps-score": 6 },
  { "satisfaction-score": 2, "nps-score": 3 }
];

export default function DashboardComponent() {
  const [dashboard, setDashboard] = useState<Dashboard | null>(null);

  useEffect(() => {
    const survey = new Model(surveyJson);

    const dashboardInstance = new Dashboard({
      questions: survey.getAllQuestions(),
      data: surveyResults,
      items: [
        "satisfaction-score",
        {
          name: "nps-score",
          type: "nps"
        }
      ]
    });

    setDashboard(dashboardInstance);

    dashboardInstance.render("dashboard");

    return () => {
      dashboardInstance.clear();
    };
  }, []);

  return (
    <div id="dashboard" />
  );
}
// dashboard/page.tsx
import dynamic from "next/dynamic";

const Dashboard = dynamic(() => import('@/components/Dashboard'), {
  ssr: false,
});

export default function SurveyDashboard() {
  return (
    <Dashboard />
  );
}

View Full Code on GitHub

Activate a SurveyJS License

SurveyJS Dashboard is not available for free commercial use. To integrate it into your application, you must purchase a commercial license for the software developer(s) who will be working with the Dashboard APIs and implementing the integration. If you use SurveyJS Dashboard without a license, an alert banner will appear at the top of the interface:

SurveyJS Dashboard: Alert banner

After purchasing a license, follow the steps below to activate it and remove the alert banner:

  1. Log in to the SurveyJS website using your email address and password. If you've forgotten your password, request a reset and check your inbox for the reset link.
  2. Open the following page: How to Remove the Alert Banner. You can also access it by clicking Set up your license key in the alert banner itself.
  3. Follow the instructions on that page.

Once you've completed the setup correctly, the alert banner will no longer appear.

See Also

Dashboard Demo Examples

Send feedback to the SurveyJS team

Need help? Visit our support page

Your cookie settings

We use cookies to make your browsing experience more convenient and personal. Some cookies are essential, while others help us analyse traffic. Your personal data and cookies may be used for ad personalization. By clicking “Accept All”, you consent to the use of all cookies as described in our Terms of Use and Privacy Statement. You can manage your preferences in “Cookie settings.”

Your renewal subscription expires soon.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Your renewal subscription has expired.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Add Survey Analytics to a Vue Application
This step-by-step tutorial will help you get started with Survey Analytics in a Vue application. To add Survey Analytics to your application, follow the steps below:
- Install the
survey-analytics
npm Package - Configure Styles
- Load Survey Results
- Configure the Visualization Panel
- Render the Visualization Panel
As a result, you will create the following dashboard:
You can find the full code for this tutorial in the following GitHub repository: Get Started with SurveyJS Analytics - Vue.
Install the survey-analytics
npm Package
Survey Analytics is distributed as a survey-analytics npm package. Run the following command to install it:
npm install survey-analytics --save
Survey Analytics depends on the Plotly.js and Wordcloud libraries. Wordcloud is used to visualize the Text, Multiple Text, and Comment question types. Plotly.js is used to visualize the rest of the question types. The command above installs both these libraries as dependencies.
Configure Styles
Import the Survey Analytics style sheet as shown below:
<script>
import 'survey-analytics/survey.analytics.min.css';
</script>
Load Survey Results
You can access survey results as a JSON object within the SurveyModel
's onComplete
event handler. Send the results to your server and store them with a specific survey ID. Refer to the Handle Survey Completion help topic for more information.
To load the survey results, send the survey ID to your server and return an array of JSON objects:
<script>
// ...
const SURVEY_ID = 1;
export default {
mounted() {
loadSurveyResults("https://your-web-service.com/" + SURVEY_ID)
.then((surveyResults) => {
// ...
// Configure and render the Visualization Panel here
// Refer to the help topics below
// ...
});
}
}
function loadSurveyResults (url) {
return new Promise((resolve, reject) => {
const request = new XMLHttpRequest();
request.open('GET', url);
request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
request.onload = () => {
const response = request.response ? JSON.parse(request.response) : [];
resolve(response);
}
request.onerror = () => {
reject(request.statusText);
}
request.send();
});
}
</script>
For demonstration purposes, this tutorial uses predefined survey results. The following code shows a survey model and the structure of the survey results array:
const surveyJson = {
elements: [{
name: "satisfaction-score",
title: "How would you describe your experience with our product?",
type: "radiogroup",
choices: [
{ value: 5, text: "Fully satisfying" },
{ value: 4, text: "Generally satisfying" },
{ value: 3, text: "Neutral" },
{ value: 2, text: "Rather unsatisfying" },
{ value: 1, text: "Not satisfying at all" }
],
isRequired: true
}, {
name: "nps-score",
title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
type: "rating",
rateMin: 0,
rateMax: 10,
}],
showQuestionNumbers: "off",
completedHtml: "Thank you for your feedback!",
};
const surveyResults = [{
"satisfaction-score": 5,
"nps-score": 10
}, {
"satisfaction-score": 5,
"nps-score": 9
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 2,
"nps-score": 3
}];
Configure the Visualization Panel
Analytics charts are displayed in a Visualization Panel. Specify its properties in a configuration object. In this tutorial, the object enables the allowHideQuestions
property:
const vizPanelOptions = {
allowHideQuestions: false
}
Pass the configuration object, survey questions, and results to the VisualizationPanel
constructor as shown in the code below to instantiate the Visualization Panel. Assign the produced instance to a constant that will be used later to render the component:
<script>
// ...
import { Model } from 'survey-core';
import { VisualizationPanel } from 'survey-analytics';
const surveyJson = { /* ... */ };
const surveyResults = [ /* ... */ ];
const vizPanelOptions = { /* ... */ };
export default {
mounted() {
const survey = new Model(surveyJson);
const vizPanel = new VisualizationPanel(
survey.getAllQuestions(),
surveyResults,
vizPanelOptions
);
}
}
</script>
View full code
<template>
</template>
<script>
import 'survey-analytics/survey.analytics.min.css';
import { Model } from 'survey-core';
import { VisualizationPanel } from 'survey-analytics';
const surveyJson = {
elements: [{
name: "satisfaction-score",
title: "How would you describe your experience with our product?",
type: "radiogroup",
choices: [
{ value: 5, text: "Fully satisfying" },
{ value: 4, text: "Generally satisfying" },
{ value: 3, text: "Neutral" },
{ value: 2, text: "Rather unsatisfying" },
{ value: 1, text: "Not satisfying at all" }
],
isRequired: true
}, {
name: "nps-score",
title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
type: "rating",
rateMin: 0,
rateMax: 10,
}],
showQuestionNumbers: "off",
completedHtml: "Thank you for your feedback!",
};
const surveyResults = [{
"satisfaction-score": 5,
"nps-score": 10
}, {
"satisfaction-score": 5,
"nps-score": 9
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 2,
"nps-score": 3
}];
const vizPanelOptions = {
allowHideQuestions: false
}
export default {
name: 'survey-analytics',
mounted() {
const survey = new Model(surveyJson);
const vizPanel = new VisualizationPanel(
survey.getAllQuestions(),
surveyResults,
vizPanelOptions
);
}
}
</script>
Render the Visualization Panel
Switch to the component template. Add a page element that will serve as the Visualization Panel container:
<template>
<div id="surveyVizPanel" />
</template>
To render the Visualization Panel in the page element, call the render(containerId)
method on the Visualization Panel instance you created in the previous step:
<script>
// ...
export default {
mounted() {
// ...
vizPanel.render("surveyVizPanel");
}
}
</script>
To view the application, run npm run serve
in a command line and open http://localhost:8080/ in your browser.
View full code
<template>
<div id="surveyVizPanel" />
</template>
<script>
import 'survey-analytics/survey.analytics.min.css';
import { Model } from 'survey-core';
import { VisualizationPanel } from 'survey-analytics';
const surveyJson = {
elements: [{
name: "satisfaction-score",
title: "How would you describe your experience with our product?",
type: "radiogroup",
choices: [
{ value: 5, text: "Fully satisfying" },
{ value: 4, text: "Generally satisfying" },
{ value: 3, text: "Neutral" },
{ value: 2, text: "Rather unsatisfying" },
{ value: 1, text: "Not satisfying at all" }
],
isRequired: true
}, {
name: "nps-score",
title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
type: "rating",
rateMin: 0,
rateMax: 10,
}],
showQuestionNumbers: "off",
completedHtml: "Thank you for your feedback!",
};
const surveyResults = [{
"satisfaction-score": 5,
"nps-score": 10
}, {
"satisfaction-score": 5,
"nps-score": 9
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 3,
"nps-score": 6
}, {
"satisfaction-score": 2,
"nps-score": 3
}];
const vizPanelOptions = {
allowHideQuestions: false
}
export default {
name: 'survey-analytics',
mounted() {
const survey = new Model(surveyJson);
const vizPanel = new VisualizationPanel(
survey.getAllQuestions(),
surveyResults,
vizPanelOptions
);
vizPanel.showHeader = false;
vizPanel.render("surveyVizPanel");
}
}
</script>